﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using System.IO;
using System.Security.AccessControl;

namespace FileStreamAndNoRights {
	class Program {
		const string FileName = "Hello.txt";

		static void Main(string[] args) {

			Console.WriteLine("Creating file \"" + FileName + "\" ...");
			StreamWriter sw = File.CreateText(FileName);
			sw.WriteLine("Hello world!");
			sw.Dispose();

			Console.WriteLine("Adding deny ReadData rule for \"" + Environment.UserName + "\" user on \"" + FileName + "\" file ...");
			FileSecurity security = File.GetAccessControl(FileName);
			FileSystemAccessRule denyRule = new FileSystemAccessRule(Environment.UserName, FileSystemRights.ReadData, AccessControlType.Deny);
			security.AddAccessRule(denyRule);
			File.SetAccessControl(FileName, security);

			Console.WriteLine("Opening file \"" + FileName + "\" for reading ...");
			StreamReader sr = new StreamReader(FileName);	// File.OpenText(FileName);
			Console.Write(sr.ReadToEnd());
			sr.Dispose();
		}
	}
}
